=== modified file 'NEWS'
--- NEWS	2007-10-22 18:43:47 +0000
+++ NEWS	2007-10-22 22:31:36 +0000
@@ -24,6 +24,8 @@
         * Add buttons to navigate to child revisions.
     (Gary van der Merwe)
 
+  * Added a revert option to the revision menu. (Gary van der Merwe)
+
  BUG FIXES
 
   * Show children on new row in table to avoid very broad windows in viz. 

=== modified file 'revisionmenu.py'
--- revisionmenu.py	2007-10-21 12:14:36 +0000
+++ revisionmenu.py	2007-10-22 18:21:00 +0000
@@ -23,6 +23,7 @@
 
 import bzrlib
 import gtk
+from bzrlib import (errors, ui)
 
 class RevisionPopupMenu(gtk.Menu):
     def __init__(self, repository, revids, branch=None):
@@ -53,6 +54,18 @@
             item.connect('activate', self.store_merge_directive)
             # FIXME: self.append(item)
             self.show_all()
+            
+            self.bzrdir = self.branch.bzrdir
+            self.wt = None
+            try:
+                self.wt = self.bzrdir.open_workingtree()
+            except errors.NoWorkingTree:
+                return False
+            if self.wt :
+                item = gtk.MenuItem("_Revert to this revision")
+                item.connect('activate', self.revert)
+                self.append(item)
+                self.show_all()
 
     def store_merge_directive(self, item):
         from bzrlib.plugins.gtk.mergedirective import CreateMergeDirectiveDialog
@@ -86,3 +99,11 @@
                 self.branch.unlock()
             
             dialog.destroy()
+    
+    def revert(self, item):
+        pb = ui.ui_factory.nested_progress_bar()
+        revision_tree = self.branch.repository.revision_tree(self.revids[0])
+        try:
+            self.wt.revert(old_tree = revision_tree, pb = pb)
+        finally:
+            pb.finished()

